local jutils = require("utility.jutils")
local input = require("utility.input")
local rendering = require("utility.rendering")

local physicalentity = require("entities.physicalentity")

local bee = physicalentity:subclass("Bee")

function bee:init()
	physicalentity.init(self)

	self.texture = love.graphics.newImage("assets/entities/bee.png")
	self.boundingbox = jutils.point.new(4, 4)
	self.mass = 0
	self.direction = -1
	self.health = 15
	self.maxhealth = 15

	self.goalDirection = jutils.point.new(0, 0)
	self.fastSpeed = 40
	self.slowSpeed = 5
	self.pissedOff = false

	self.goalUpdateSpeed = 15
	self.goalUpdate = 0
end

function bee:update(dt)
	physicalentity.update(self, dt)

	self.goalUpdate = self.goalUpdate + dt

	if self.goalUpdate then

	end

	self.goalDirection = jutils.point.new(input.getTransformedMouse())
	self.velocity = (self.position-self.goalDirection):unitvec() * -self.fastSpeed
	self.velocity = self.velocity + jutils.point.new(math.random()-0.5, math.random()-0.5)*10
end

function bee:draw()

	if math.ceil(self.health) < self.maxhealth then
		rendering:setFont("pixelade_tiny")
		love.graphics.setColor(0.8, 0, 0)
		love.graphics.printf(math.ceil(self.health).."/"..math.ceil(self.maxhealth).."HP", self.position.x-20, self.position.y-self.boundingbox.y-10, 40, "center")
		rendering:setFont("default")
	end

	love.graphics.setColor(1, 1, 1)
	love.graphics.draw(self.texture,
		self.position.x, self.position.y, self.rotation,
		self.scale.x*(-self.direction), self.scale.y,
		self.textureorigin.x, self.textureorigin.y
	)
end

return bee