local jutils = require("utility.jutils")

-- TODO: make this apply to any entity affected, instead of just the player

local effects = {
	MANLET = {
		comeup = function(entity)
			entity.boundingbox = jutils.point.new(4, 6)
			entity.scale.x = 0.75
			entity.scale.y = 0.5
			entity.mass = 0.5
		end,

		tick = function(entity, dt)

		end,
		comedown = function(entity)
			entity.boundingbox = jutils.point.new(8, 12)
			entity.scale.x = 1
			entity.scale.y = 1
			entity.mass = 1.25
		end,
	},
	ACCELLERATION = {
		comeup = function(entity)
			entity.walkspeed = 120
			entity.acceleration = 1800
		end,

		tick = function(entity, dt)

		end,
		comedown = function(entity)
			entity.walkspeed = 70
			entity.acceleration = 900
		end,
	},
	LOWMASS = {
		comeup = function(entity)
			entity.scale.x = 0.6
		end,

		tick = function(entity, dt)
			entity.velocity.y = math.min(entity.velocity.y, 30)
		end,
		comedown = function(entity)
			entity.scale.x = 1
		end,
	},
	EXPLOSION = {
		comeup = function(entity)
			
		end,

		tick = function(entity, dt)

		end,
		comedown = function(entity)
			local exp = entity.world:addEntity("explosion", 30, 32, true)
			exp.nextposition = entity.nextposition
			exp.position = entity.position
		end,
	},
	HEAL = {
		comeup = function(entity)
			
		end,

		tick = function(entity, dt)
			entity.health = entity.health + (dt*5)
		end,
		comedown = function(entity)
			
		end,
	},
}

return effects